"use strict";

exports.__esModule = true;
exports.default = SupersetPluginChartHorizontalBar;

var _react = _interopRequireWildcard(require("react"));

var _core = require("@superset-ui/core");

var _plots = require("@ant-design/plots");

var _templateObject;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _taggedTemplateLiteralLoose(strings, raw) { if (!raw) { raw = strings.slice(0); } strings.raw = raw; return strings; }

// The following Styles component is a <div> element, which has been styled using Emotion
// For docs, visit https://emotion.sh/docs/styled
// Theming variables are provided for your use via a ThemeProvider
// imported from @superset-ui/core. For variables available, please visit
// https://github.com/apache-superset/superset-ui/blob/master/packages/superset-ui-core/src/style/index.ts
// Следующий компонент стилей представляет собой элемент <div>, который был стилизован с использованием Emotion
// Для получения документов посетите https://emotion.sh/docs/styled
// // Переменные тематизации предоставляются для вашего использования через ThemeProvider
// импортировано из @superset-ui/core. Для получения информации о доступных переменных, пожалуйста, посетите
// https://github.com/apache-superset/superset-ui/blob/master/packages/superset-ui-core/src/style/index.ts
var Styles = _core.styled.div(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["\n  padding: ", "px;\n  border-radius: ", "px;\n  height: ", "px;\n  width: ", "px;\n  }\n"])), _ref => {
  var {
    theme
  } = _ref;
  return theme.gridUnit * 4;
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.gridUnit * 2;
}, _ref3 => {
  var {
    height
  } = _ref3;
  return height;
}, _ref4 => {
  var {
    width
  } = _ref4;
  return width;
});
/**
 * ******************* WHAT YOU CAN BUILD HERE *******************
 *  In essence, a chart is given a few key ingredients to work with:
 *  * Data: provided via `props.data`
 *  * A DOM element
 *  * FormData (your controls!) provided as props by transformProps.ts
 * ******************* ЧТО ВЫ МОЖЕТЕ ПОСТРОИТЬ ЗДЕСЬ *******************
 * По сути, диаграмма содержит несколько ключевых компонентов для работы.:
 * * Данные: предоставлены через `props.data`
 * * Элемент DOM
 * * * * FormData (ваши элементы управления!), предоставленные в качестве реквизита transformProps.ts
 */


function SupersetPluginChartHorizontalBar(props) {
  // height and width are the height and width of the DOM element as it exists in the dashboard.
  // There is also a `data` prop, which is, of course, your DATA 🎉
  var {
    data,
    height,
    width,
    cols,
    metrics,
    groupMode,
    percentMode,
    stackMode,
    typeOfChart
  } = props;
  var rootElem = /*#__PURE__*/(0, _react.createRef)(); // Often, you just want to get a hold of the DOM and go nuts.
  // Here, you can do that with createRef, and the useEffect hook.

  (0, _react.useEffect)(() => {
    var root = rootElem.current;
    console.log("Plugin element", root);
  });
  console.log("Plugin props", props); //console.log("configFromControlPanel",configFromControlPanel.controlPanelSections)

  var configForVertical = {
    data,
    xField: cols[0],
    yField: metrics[0],
    seriesField: cols[1],
    isGroup: groupMode,
    isPercent: percentMode,
    isStack: stackMode,

    /* yAxis: {
      label: {
        autoRotate: false,
      },
    }, 
    legend: {
      position: "top-left",
    },*/
    barWidthRatio: 0.8
  };
  var configForHorizontal = {
    data,
    xField: metrics[0],
    yField: cols[0],
    seriesField: cols[1],
    isGroup: groupMode,
    isPercent: percentMode,
    isStack: stackMode,

    /* yAxis: {
      label: {
        autoRotate: false,
      },
    },
    legend: {
      position: "top-left",
    },*/
    barWidthRatio: 0.8
  };
  console.log("config", configForHorizontal);
  console.log("config", configForVertical);
  console.log("typeOfChart", typeOfChart);

  if (typeOfChart === "horizontal") {
    return /*#__PURE__*/_react.default.createElement(Styles, {
      ref: rootElem,
      boldText: props.boldText,
      headerFontSize: props.headerFontSize,
      height: height,
      width: width,
      groupMode: true,
      stackMode: true,
      percentMode: true,
      typeOfChart: "",
      cols: [],
      metrics: []
    }, /*#__PURE__*/_react.default.createElement(_plots.Bar, configForHorizontal));
  } else {
    return /*#__PURE__*/_react.default.createElement(Styles, {
      ref: rootElem,
      boldText: props.boldText,
      headerFontSize: props.headerFontSize,
      height: height,
      width: width,
      groupMode: true,
      stackMode: true,
      percentMode: true,
      typeOfChart: "",
      cols: [],
      metrics: []
    }, /*#__PURE__*/_react.default.createElement(_plots.Column, configForVertical));
  }
}

{
  /* <h3>{props.headerText}</h3>
  <pre>${JSON.stringify(data, null, 2)}</pre>
  */
}